// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package visit

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// VisitClient is the client API for Visit service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type VisitClient interface {
	// Subscribe ...
	Subscribe(ctx context.Context, in *Subscriber, opts ...grpc.CallOption) (*Void, error)
	// Unsubscribe ...
	Unsubscribe(ctx context.Context, in *Subscriber, opts ...grpc.CallOption) (*Void, error)
	// GetPreferences ...
	GetPreferences(ctx context.Context, in *Subscriber, opts ...grpc.CallOption) (*Preferences, error)
	// SetPreferences ...
	SetPreferences(ctx context.Context, in *Preferences, opts ...grpc.CallOption) (*Void, error)
	// GetJobTags ...
	GetJobTags(ctx context.Context, in *Void, opts ...grpc.CallOption) (Visit_GetJobTagsClient, error)
	// GetJobCategories ...
	GetJobCategories(ctx context.Context, in *Void, opts ...grpc.CallOption) (Visit_GetJobCategoriesClient, error)
	// GetBrands ...
	GetBrands(ctx context.Context, in *Void, opts ...grpc.CallOption) (Visit_GetBrandsClient, error)
	// GetJobOffers ...
	GetJobOffers(ctx context.Context, in *Void, opts ...grpc.CallOption) (Visit_GetJobOffersClient, error)
	// ListContacts returns a list of all contacts (Companies, Brands, Persons) in VISIT
	ListContacts(ctx context.Context, in *ListContactsRequest, opts ...grpc.CallOption) (*ListContactsResponse, error)
}

type visitClient struct {
	cc grpc.ClientConnInterface
}

func NewVisitClient(cc grpc.ClientConnInterface) VisitClient {
	return &visitClient{cc}
}

func (c *visitClient) Subscribe(ctx context.Context, in *Subscriber, opts ...grpc.CallOption) (*Void, error) {
	out := new(Void)
	err := c.cc.Invoke(ctx, "/vseth.vis.visit.Visit/Subscribe", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *visitClient) Unsubscribe(ctx context.Context, in *Subscriber, opts ...grpc.CallOption) (*Void, error) {
	out := new(Void)
	err := c.cc.Invoke(ctx, "/vseth.vis.visit.Visit/Unsubscribe", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *visitClient) GetPreferences(ctx context.Context, in *Subscriber, opts ...grpc.CallOption) (*Preferences, error) {
	out := new(Preferences)
	err := c.cc.Invoke(ctx, "/vseth.vis.visit.Visit/GetPreferences", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *visitClient) SetPreferences(ctx context.Context, in *Preferences, opts ...grpc.CallOption) (*Void, error) {
	out := new(Void)
	err := c.cc.Invoke(ctx, "/vseth.vis.visit.Visit/SetPreferences", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *visitClient) GetJobTags(ctx context.Context, in *Void, opts ...grpc.CallOption) (Visit_GetJobTagsClient, error) {
	stream, err := c.cc.NewStream(ctx, &Visit_ServiceDesc.Streams[0], "/vseth.vis.visit.Visit/GetJobTags", opts...)
	if err != nil {
		return nil, err
	}
	x := &visitGetJobTagsClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type Visit_GetJobTagsClient interface {
	Recv() (*JobTag, error)
	grpc.ClientStream
}

type visitGetJobTagsClient struct {
	grpc.ClientStream
}

func (x *visitGetJobTagsClient) Recv() (*JobTag, error) {
	m := new(JobTag)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func (c *visitClient) GetJobCategories(ctx context.Context, in *Void, opts ...grpc.CallOption) (Visit_GetJobCategoriesClient, error) {
	stream, err := c.cc.NewStream(ctx, &Visit_ServiceDesc.Streams[1], "/vseth.vis.visit.Visit/GetJobCategories", opts...)
	if err != nil {
		return nil, err
	}
	x := &visitGetJobCategoriesClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type Visit_GetJobCategoriesClient interface {
	Recv() (*JobCategory, error)
	grpc.ClientStream
}

type visitGetJobCategoriesClient struct {
	grpc.ClientStream
}

func (x *visitGetJobCategoriesClient) Recv() (*JobCategory, error) {
	m := new(JobCategory)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func (c *visitClient) GetBrands(ctx context.Context, in *Void, opts ...grpc.CallOption) (Visit_GetBrandsClient, error) {
	stream, err := c.cc.NewStream(ctx, &Visit_ServiceDesc.Streams[2], "/vseth.vis.visit.Visit/GetBrands", opts...)
	if err != nil {
		return nil, err
	}
	x := &visitGetBrandsClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type Visit_GetBrandsClient interface {
	Recv() (*Brand, error)
	grpc.ClientStream
}

type visitGetBrandsClient struct {
	grpc.ClientStream
}

func (x *visitGetBrandsClient) Recv() (*Brand, error) {
	m := new(Brand)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func (c *visitClient) GetJobOffers(ctx context.Context, in *Void, opts ...grpc.CallOption) (Visit_GetJobOffersClient, error) {
	stream, err := c.cc.NewStream(ctx, &Visit_ServiceDesc.Streams[3], "/vseth.vis.visit.Visit/GetJobOffers", opts...)
	if err != nil {
		return nil, err
	}
	x := &visitGetJobOffersClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type Visit_GetJobOffersClient interface {
	Recv() (*JobOffer, error)
	grpc.ClientStream
}

type visitGetJobOffersClient struct {
	grpc.ClientStream
}

func (x *visitGetJobOffersClient) Recv() (*JobOffer, error) {
	m := new(JobOffer)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func (c *visitClient) ListContacts(ctx context.Context, in *ListContactsRequest, opts ...grpc.CallOption) (*ListContactsResponse, error) {
	out := new(ListContactsResponse)
	err := c.cc.Invoke(ctx, "/vseth.vis.visit.Visit/ListContacts", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// VisitServer is the server API for Visit service.
// All implementations must embed UnimplementedVisitServer
// for forward compatibility
type VisitServer interface {
	// Subscribe ...
	Subscribe(context.Context, *Subscriber) (*Void, error)
	// Unsubscribe ...
	Unsubscribe(context.Context, *Subscriber) (*Void, error)
	// GetPreferences ...
	GetPreferences(context.Context, *Subscriber) (*Preferences, error)
	// SetPreferences ...
	SetPreferences(context.Context, *Preferences) (*Void, error)
	// GetJobTags ...
	GetJobTags(*Void, Visit_GetJobTagsServer) error
	// GetJobCategories ...
	GetJobCategories(*Void, Visit_GetJobCategoriesServer) error
	// GetBrands ...
	GetBrands(*Void, Visit_GetBrandsServer) error
	// GetJobOffers ...
	GetJobOffers(*Void, Visit_GetJobOffersServer) error
	// ListContacts returns a list of all contacts (Companies, Brands, Persons) in VISIT
	ListContacts(context.Context, *ListContactsRequest) (*ListContactsResponse, error)
	mustEmbedUnimplementedVisitServer()
}

// UnimplementedVisitServer must be embedded to have forward compatible implementations.
type UnimplementedVisitServer struct {
}

func (UnimplementedVisitServer) Subscribe(context.Context, *Subscriber) (*Void, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Subscribe not implemented")
}
func (UnimplementedVisitServer) Unsubscribe(context.Context, *Subscriber) (*Void, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Unsubscribe not implemented")
}
func (UnimplementedVisitServer) GetPreferences(context.Context, *Subscriber) (*Preferences, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetPreferences not implemented")
}
func (UnimplementedVisitServer) SetPreferences(context.Context, *Preferences) (*Void, error) {
	return nil, status.Errorf(codes.Unimplemented, "method SetPreferences not implemented")
}
func (UnimplementedVisitServer) GetJobTags(*Void, Visit_GetJobTagsServer) error {
	return status.Errorf(codes.Unimplemented, "method GetJobTags not implemented")
}
func (UnimplementedVisitServer) GetJobCategories(*Void, Visit_GetJobCategoriesServer) error {
	return status.Errorf(codes.Unimplemented, "method GetJobCategories not implemented")
}
func (UnimplementedVisitServer) GetBrands(*Void, Visit_GetBrandsServer) error {
	return status.Errorf(codes.Unimplemented, "method GetBrands not implemented")
}
func (UnimplementedVisitServer) GetJobOffers(*Void, Visit_GetJobOffersServer) error {
	return status.Errorf(codes.Unimplemented, "method GetJobOffers not implemented")
}
func (UnimplementedVisitServer) ListContacts(context.Context, *ListContactsRequest) (*ListContactsResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method ListContacts not implemented")
}
func (UnimplementedVisitServer) mustEmbedUnimplementedVisitServer() {}

// UnsafeVisitServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to VisitServer will
// result in compilation errors.
type UnsafeVisitServer interface {
	mustEmbedUnimplementedVisitServer()
}

func RegisterVisitServer(s grpc.ServiceRegistrar, srv VisitServer) {
	s.RegisterService(&Visit_ServiceDesc, srv)
}

func _Visit_Subscribe_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(Subscriber)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(VisitServer).Subscribe(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.vis.visit.Visit/Subscribe",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(VisitServer).Subscribe(ctx, req.(*Subscriber))
	}
	return interceptor(ctx, in, info, handler)
}

func _Visit_Unsubscribe_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(Subscriber)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(VisitServer).Unsubscribe(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.vis.visit.Visit/Unsubscribe",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(VisitServer).Unsubscribe(ctx, req.(*Subscriber))
	}
	return interceptor(ctx, in, info, handler)
}

func _Visit_GetPreferences_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(Subscriber)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(VisitServer).GetPreferences(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.vis.visit.Visit/GetPreferences",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(VisitServer).GetPreferences(ctx, req.(*Subscriber))
	}
	return interceptor(ctx, in, info, handler)
}

func _Visit_SetPreferences_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(Preferences)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(VisitServer).SetPreferences(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.vis.visit.Visit/SetPreferences",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(VisitServer).SetPreferences(ctx, req.(*Preferences))
	}
	return interceptor(ctx, in, info, handler)
}

func _Visit_GetJobTags_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(Void)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(VisitServer).GetJobTags(m, &visitGetJobTagsServer{stream})
}

type Visit_GetJobTagsServer interface {
	Send(*JobTag) error
	grpc.ServerStream
}

type visitGetJobTagsServer struct {
	grpc.ServerStream
}

func (x *visitGetJobTagsServer) Send(m *JobTag) error {
	return x.ServerStream.SendMsg(m)
}

func _Visit_GetJobCategories_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(Void)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(VisitServer).GetJobCategories(m, &visitGetJobCategoriesServer{stream})
}

type Visit_GetJobCategoriesServer interface {
	Send(*JobCategory) error
	grpc.ServerStream
}

type visitGetJobCategoriesServer struct {
	grpc.ServerStream
}

func (x *visitGetJobCategoriesServer) Send(m *JobCategory) error {
	return x.ServerStream.SendMsg(m)
}

func _Visit_GetBrands_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(Void)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(VisitServer).GetBrands(m, &visitGetBrandsServer{stream})
}

type Visit_GetBrandsServer interface {
	Send(*Brand) error
	grpc.ServerStream
}

type visitGetBrandsServer struct {
	grpc.ServerStream
}

func (x *visitGetBrandsServer) Send(m *Brand) error {
	return x.ServerStream.SendMsg(m)
}

func _Visit_GetJobOffers_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(Void)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(VisitServer).GetJobOffers(m, &visitGetJobOffersServer{stream})
}

type Visit_GetJobOffersServer interface {
	Send(*JobOffer) error
	grpc.ServerStream
}

type visitGetJobOffersServer struct {
	grpc.ServerStream
}

func (x *visitGetJobOffersServer) Send(m *JobOffer) error {
	return x.ServerStream.SendMsg(m)
}

func _Visit_ListContacts_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ListContactsRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(VisitServer).ListContacts(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.vis.visit.Visit/ListContacts",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(VisitServer).ListContacts(ctx, req.(*ListContactsRequest))
	}
	return interceptor(ctx, in, info, handler)
}

// Visit_ServiceDesc is the grpc.ServiceDesc for Visit service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var Visit_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "vseth.vis.visit.Visit",
	HandlerType: (*VisitServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "Subscribe",
			Handler:    _Visit_Subscribe_Handler,
		},
		{
			MethodName: "Unsubscribe",
			Handler:    _Visit_Unsubscribe_Handler,
		},
		{
			MethodName: "GetPreferences",
			Handler:    _Visit_GetPreferences_Handler,
		},
		{
			MethodName: "SetPreferences",
			Handler:    _Visit_SetPreferences_Handler,
		},
		{
			MethodName: "ListContacts",
			Handler:    _Visit_ListContacts_Handler,
		},
	},
	Streams: []grpc.StreamDesc{
		{
			StreamName:    "GetJobTags",
			Handler:       _Visit_GetJobTags_Handler,
			ServerStreams: true,
		},
		{
			StreamName:    "GetJobCategories",
			Handler:       _Visit_GetJobCategories_Handler,
			ServerStreams: true,
		},
		{
			StreamName:    "GetBrands",
			Handler:       _Visit_GetBrands_Handler,
			ServerStreams: true,
		},
		{
			StreamName:    "GetJobOffers",
			Handler:       _Visit_GetJobOffers_Handler,
			ServerStreams: true,
		},
	},
	Metadata: "vseth/vis/visit/visit.proto",
}
